//xsetaseta@gmail.com
//
//ARDUV3
//12/06/2019

//17 Salidas
//5 entradas analogicas

//___________
char clave[]="ARDUV3";

char entrada[100];
int  trozos[10];
int  trozosVal[10];
int contador;
boolean stringComplete = false;
char * puntero;


int sensorValue = 0;

void setup()
{
  Serial.begin(9600);
  for(contador=2;contador<=13;contador++) pinMode(contador, OUTPUT);  //SALIDAS DIGI. 3-13
  for(contador=14;contador<=19;contador++)  pinMode(contador, INPUT);// ENTRADAS ANALOG. 0-5
  contador=0; 
  
  delay(100);
  Serial.println(clave);  
  delay(100);
   
}

void loop()
{
  int z, i;

  while (Serial.available())
  {
    char inChar = (char)Serial.read();
    entrada[contador] = inChar;
    if (inChar == '\n')
    {
      stringComplete = true;
      entrada[contador] = 0;
    }
    contador++;
  }


  if (stringComplete)
  {
    Serial.println(entrada);
    for (z = 0; z < 10; z++)trozos[z] = 0;
    trozos[0] = 0;
    for (z = 0, i = 1; z < 100 && z < contador ; z++)
    {
      if (entrada[z] > 96 && entrada[z] < 123) entrada[z] -= 32; //mayusculas
      if (entrada[z] < 32) entrada[z] = 32;
      if (entrada[z] == ',' || entrada[z] == ' '|| entrada[z] == '.' )
      {
        entrada[z] = 0;
        trozos[i] = z + 1;
        trozosVal[i] = atol(entrada + trozos[i]);
        i++;
      }
    }

    for (z = 0; z < 10 ; z++)
    {
      if (trozos[z] == 0 && z != 0) break;
      puntero = entrada + trozos[z];
    }

    z = strlen(entrada);
    switch (z)
    { 
      case 3: 
        if (!strncmp(entrada, "SET", 3))
        { 
          Serial.print("#SET"); Serial.print(" ");  Serial.print(trozosVal[1]); Serial.print(","); Serial.println(trozosVal[2]);
          if(trozosVal[1]>1 && trozosVal[1]<14)
            {
              digitalWrite(trozosVal[1], trozosVal[2]);                   
              goto salir0;
            }
        }  

        if (!strncmp(entrada, "ANA", 3))
        { 
          Serial.print("#ANA"); Serial.print(" ");  Serial.println(trozosVal[1]); 
          if(trozosVal[1]>=0 && trozosVal[1]<8)
            {
              sensorValue = analogRead(trozosVal[1]);
              Serial.print("VAL"); Serial.print(",");  Serial.print(trozosVal[1]); Serial.print(","); Serial.println(sensorValue);                   
              goto salir0;
            }
        }  

        
      break;     
      case 4:        
        if (!strncmp(entrada, "HELP", 4))
        {
          Serial.println("_____HELP_____");
          Serial.println("ARDUV3");
          Serial.println("SET [2-13],[0-1]");
          Serial.println("ANA [0-7]");
          
          goto salir0;
        }
        break;
      case 6:  
         if(!strcmp(entrada,"IPORTB"))
            {
             Serial.print("RPORTB,");  Serial.println(PINB);
             goto salir0;
            }
      
         if(!strcmp(entrada,"IPORTC"))
            {
             Serial.print("RPORTC,");  Serial.println(PINC);   
             goto salir0;
            }
         if(!strcmp(entrada,"IPORTD"))
            {
              Serial.print("RPORTD,"); Serial.println(PIND);    
             goto salir0;
            }          
         if (!strncmp(entrada, clave, 6))   {  Serial.println("OK");  goto salir0;   }
      break;
     
    }
error0:
    Serial.print("ERROR ");  Serial.println(entrada);
salir0:
    Serial.println("______________");
    contador = 0;
    stringComplete = false;
    for (z = 0; z < 100 ; z++)entrada[z] = 0;
  }

}


